// Arduino version of the PIC microcontroller Slot Machine

#include "LCD_4Bit.h"

#define Click A0
#define LED1 A1
#define LED2 A2
#define Coin_Sw A3
#define Door A4
#define Sound A5

#define Num_Clicks 4

byte Random;
byte Digit1;
byte Digit2;
byte Digit3;

void setup() {
  pinMode(Click, OUTPUT);
  pinMode(LED1, OUTPUT);
  pinMode(LED2, OUTPUT);
  pinMode(Coin_Sw, INPUT_PULLUP);
  pinMode(Door, OUTPUT);
  pinMode(Sound, OUTPUT);
  LCD_setup();
  No_Digits();
}

void loop() {
  Random++;
  if (digitalRead(Coin_Sw) == LOW)
    Spin();
}

void Spin() {
  if (Random == 0)
    Winner('0');
  else if (Random == 8)
    Winner('0');
  else if (Random == 16)
    Winner('0');
  else if (Random == 24)
    Winner('0');

  else if (Random == 32)
    Winner('1');
  else if (Random == 40)
    Winner('1');
  else if (Random == 48)
    Winner('1');
  else if (Random == 56)
    Winner('1');

  else if (Random == 64)
    Winner('2');
  else if (Random == 72)
    Winner('2');
  else if (Random == 80)
    Winner('2');
  else if (Random == 88)
    Winner('2');

  else if (Random == 96)
    Winner('3');
  else if (Random == 104)
    Winner('3');
  else if (Random == 112)
    Winner('3');
  else if (Random == 120)
    Winner('3');

  else if (Random == 128)
    Winner('4');
  else if (Random == 136)
    Winner('4');
  else if (Random == 144)
    Winner('4');
  else if (Random == 152)
    Winner('4');

  else if (Random == 160)
    Winner('5');
  else if (Random == 168)
    Winner('5');
  else if (Random == 176)
    Winner('5');
  else if (Random == 184)
    Winner('5');

  else if (Random == 192)
    Winner('6');
  else if (Random == 200)
    Winner('6');
  else if (Random == 208)
    Winner('6');
  else if (Random == 216)
    Winner('6');

  else if (Random == 224)
    Winner('7');
  else if (Random == 232)
    Winner('7');
  else if (Random == 240)
    Winner('7');
  else if (Random == 248)
    Winner('7');

  else
    Loser();
}

void Winner(byte Disp_Val) {
  Digit1 = Disp_Val;
  Digit2 = Disp_Val;
  Digit3 = Disp_Val;
  New_Digits();
  LED_Blink();
  LED_Blink();
  Message_On();
  LED_Blink();
  LED_Blink();
  LED_Blink();
  LED_Blink();
  LED_Blink();
  LED_Blink();
  LED_Blink();
  LED_Blink();
  LED_Blink();
  LED_Blink();
  digitalWrite(Door, HIGH); // open the door
  LED_Blink();
  LED_Blink();
  LED_Blink();
  digitalWrite(Door, LOW); // release door solenoid
  delay(1000);
}

void Loser() {
  No_Digits();
  Digit1 = (Random / 32) + 0x30;
  Digit2 = (Random & 0x07) + 0x30;
  Digit3 = ((Random >> 4) & 0x07) + 0x30;

  // Check for an accidental match
  if ((Digit1 == Digit2) & (Digit2 == Digit3))
    Digit3 = '0';

  New_Digits();
}

void No_Digits() {
  LCD_Line1();
  Send_Byte('[');
  Send_Byte(' ');
  Send_Byte('?');
  Send_Byte(' ');
  Send_Byte(']');
  Send_Byte('[');
  Send_Byte(' ');
  Send_Byte('?');
  Send_Byte(' ');
  Send_Byte(']');
  Send_Byte('[');
  Send_Byte(' ');
  Send_Byte('?');
  Send_Byte(' ');
  Send_Byte(']');
  delay(100);
}

void New_Digits() {
  LCD_Char_Loc(0x82, ' ');
  Clickit();
  LCD_Char_Loc(0x87, ' ');
  Clickit();
  LCD_Char_Loc(0x8C, ' ');
  Clickit();

  LCD_Char_Loc(0x82, '?');
  Clickit();
  LCD_Char_Loc(0x87, '?');
  Clickit();
  LCD_Char_Loc(0x8C, '?');
  Clickit();

  LCD_Char_Loc(0x82, ' ');
  Clickit();
  LCD_Char_Loc(0x87, ' ');
  Clickit();
  LCD_Char_Loc(0x8C, ' ');
  Clickit();

  LCD_Char_Loc(0x82, Digit1);
  Clickit();
  LCD_Char_Loc(0x87, '?');
  Clickit();
  LCD_Char_Loc(0x8C, '?');
  Clickit();

  LCD_Char_Loc(0x82, Digit1);
  Clickit();
  LCD_Char_Loc(0x87, ' ');
  Clickit();
  LCD_Char_Loc(0x8C, ' ');
  Clickit();

  LCD_Char_Loc(0x82, Digit1);
  Clickit();
  LCD_Char_Loc(0x87, Digit2);
  Clickit();
  LCD_Char_Loc(0x8C, '?');
  Clickit();

  LCD_Char_Loc(0x82, Digit1);
  Clickit();
  LCD_Char_Loc(0x87, Digit2);
  Clickit();
  LCD_Char_Loc(0x8C, ' ');
  Clickit();

  LCD_Char_Loc(0x82, Digit1);
  Clickit();
  LCD_Char_Loc(0x87, Digit2);
  Clickit();
  LCD_Char_Loc(0x8C, Digit3);
}

void Clickit() {
  byte i;

  for (i = 0; i <= Num_Clicks; i++) {
    digitalWrite(Click, HIGH);
    delay(2);
    digitalWrite(Click, LOW);
    delay(100);
  }
}

void LED_Blink() {
  digitalWrite(LED1, HIGH);
  delay(200);
  digitalWrite(LED1, LOW);
  digitalWrite(LED2, HIGH);
  delay(200);
  digitalWrite(LED2, LOW);
}

void Message_On() {
  digitalWrite(Sound, HIGH);
  delayMicroseconds(1);
  digitalWrite(Sound, LOW);
}
